#include <stdio.h>
#include <dir.h>
#include <io.h>
#include <windows.h>

#define YES (1)
#define NO (0)
//#define TRUE YES
//#define FALSE NO

#define _f  /* harmless prototoype catcher. */
#define _v  /* like same for vars. */


/****************************************************************************
****************************************************************************/

#define FIXQ YES
/****************************************************************************
This is the C-language version. After that nasty string-based C-- version,
it's so refreshing.
****************************************************************************/
#if FIXQ

/****************************************************************************
****************************************************************************/
/* scan off of spaces in s; stop at any non-blank, including \0, \n. Return
1 if end of line -- \n \0, else 0. Mon 05-15-1995 version.*/
_f int scans(char **s) {
  while (**s && (((unsigned char)**s)<=' ') && (**s != '\n') )
  ++(*s);

  return **s=='\n' || **s=='\0';
}

/****************************************************************************
****************************************************************************/

#define FIXQUOTES fakeargv(argv[0]); argv=Gargv; argc=Gargc;

int Gargc;
#define NARGV (35)

char
*args,
*Gargv[NARGV+2];

typedef enum {
  QuoteQuote = 1,
  actualQuote,
  notQuote,
  TripleQuote   //it's a long story.
} QUOTEY;

//returns \0 for nonexistent character.
_f char es(char *s, int at) {
  if ((at<0) || (at>=strlen(s)))
  return '\0';
  return s[at];
}

void erase(char *s, int start, int count) {
  int i, length=strlen(s);
  for (i=start, count+start; i<length; ++i, ++count) {
    if (count>=length) {
      s[i]='\0';
      break;
    }
    s[i]=s[count];
  }
}

/****************************************************************************
In this C-language version, we don't delete anything. Caller must handle....
****************************************************************************/
_f QUOTEY quotation(char *s) {
  if (s[0]=='"') {
    if (es(s,1)=='"') {
      if (es(s,2)=='"') {
        return TripleQuote; //leaving a single Dquote.
      }
      return QuoteQuote;    //leaving a single Dquote.
    }
    return actualQuote;     //leaving no Dquote.
  }
  return notQuote;
}

// so apparently GetCommandLine *has* arg0! Who knew?
_f void fakeargv(char *argv0) {
  int i;
  int quoting=NO;

  enum {
    fakeLOOKING,
    fakeSTARTING,
    fakeDOING
  } state=fakeLOOKING;

  char *cmdline = strdup(GetCommandLine());
  Gargc=0;        //where we start doing.

  while(*cmdline) {
    switch (state) {
      case fakeLOOKING:
      if (scans(&cmdline))
      goto ENDCMDLINE;

      state = fakeSTARTING;
//      break;

      case fakeSTARTING:
      Gargv[Gargc++] = cmdline;    //log the arg beginning.
      state = fakeDOING;

      switch (quotation(cmdline)) {
        case actualQuote:         //at beginning this means he wants a quoted
                                  //thing.
        erase(cmdline,0,1);       //delete the quote. 'N fall thru to 3quote
                                  //logic.
        quoting = YES;

        break;

        case TripleQuote:         //we assume he wants quoted, *with* a
                                  //leading dquote.
        erase(cmdline,0,2);       //so we erase two of them.

        quoting = YES;            //flag situation.
        break;

        case QuoteQuote:          //He wants a quote literal but not
                                  //quoting(?).
        erase(cmdline,0,1);       //so leave one....
        break;

//      case notQuote:            //this is the normal argument situation.
//      break;
      }
      break;                      //the switch(state).

      case fakeDOING:
      switch(quotation(cmdline)) {
        case TripleQuote:         //he wants a literal qoute, and termination.
        erase(cmdline,0,1);       //leaving a literal, and a quote to
                                  //bludgeon.
        ++cmdline;                //skip the literal.
        //fall thru to actualQuote.

        case actualQuote:
        *cmdline = '\0';        //bludgeon quote, terminate current argument.
        quoting=NO;
        //so even if we *aren't* quoting, we assume a lonely quote is a
        //terminator. It's actually an error but to hoo with it.
        state = fakeLOOKING;
        break;

        case QuoteQuote:
        erase(cmdline,0,1);       //wants literal, and he shall have it.
        break;

        case notQuote:
        if (isspace(*cmdline) && (!quoting) ) {
          *cmdline = '\0';        //bludgeon space.
          state = fakeLOOKING;
        }
        break;                    //and carry-on....


      }
      break;                      //switch(state);


    }                             //close switch(state).

    ++cmdline;                    //next.

  }

  ENDCMDLINE:
  Gargv[Gargc]=NULL;
  Gargv[0]=argv0; //include magical exec location!

}

#else   //FIXQ

#define FIXQUOTES //nada.

#endif


/****************************************************************************
****************************************************************************/

#define STARTADIR (0)

main(int argc, char *argv[]) {
  int i;

  fprintf(stderr,"\"arguments broke [etc]\": show unfixed arguments\n");

  if (
  (argc<2)
  || stricmp(argv[1],"broke")
  ) {
    FIXQUOTES;
  }

  for (i=0; i<argc; ++i)
  printf("%d:%s\n",i,argv[i]);

#if STARTADIR
  system("start /w testdir.bat");
#endif

  return 0;
}
